选择单条曲线偏置选择参考点

本文详细探讨了如何在CAD软件中选择单条曲线进行偏置操作,并强调了参考点的选择对结果的影响。通过实例分析,阐述了不同参考点选取对于曲线偏置形状和精度的决定性作用,旨在帮助用户更精确地控制几何造型。
摘要由CSDN通过智能技术生成
 public int apply_cb()
    {
        int errorCode = 0;
        try
        {
            //---- Enter your callback code here -----
            NXOpen.Session theSession = NXOpen.Session.GetSession();
            NXOpen.Part workPart = theSession.Parts.Work;
            NXOpen.Part displayPart = theSession.Parts.Display;

            TaggedObject[] curves = edge_select0.GetSelectedObjects();
            NXOpen.TaggedObject[] pointsObjects = point0.GetSelectedObjects();
            NXOpen.Point point = null;
            if (curves.Length <= 1 && pointsObjects.Length > 0)
            {
                point = (NXOpen.Point)pointsObjects[0];
            }
            double distance = double0.Value;
            //bool i = toggle0.Value;
            //double x1 = point0.Point.X;
            //double y1 = point0.Point.Y;
            //double z1 = point0.Point.Z;
            OffsetCurve(curves, point,toggle0.Value);

            // ----------------------------------------------

        }
        catch (Exception ex)
        {
            //---- Enter your exception handling code here -----
            errorCode = 1;
            theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString());
        }
        return errorCode;
    }

    private void CreateOffset(NXOpen.TaggedObject[] curves1, double distance, bool i, NXOpen.Point pointOnOffsetPlane = null)
    {
        //NXOpen.Session theSession = NXOpen.Session.GetSession();
        NXOpen.Part workPart = theSession.Parts.Work;
        NXOpen.Part displayPart = theSession.Parts.Display;
        // ----------------------------------------------
        //   菜单:镶块->Curve from Curves->Offset...
        // ----------------------------------------------
        //Arc arc1 = (Arc)workPart.Arcs.FindObject("ENTITY 5 1 1");
        //Curve[] curves1 = new Curve[1] { arc1 };


        NXOpen.Session.UndoMarkId markId1 = theSession.SetUndoMark(NXOpen.Session.MarkVisibility.Visible, "Start");
        theSession.SetUndoMarkName(markId1, "Offset Curve 对话框");

        if (!workPart.Preferences.Modeling.GetHistoryMode())
        {
            throw new System.Exception("Create or edit of a Feature was recorded in History Mode but playback is in History-Free Mode.");
        }

        NXOpen.Features.OffsetCurveBuilder offsetCurveBuilder1 = workPart.Features.CreateOffsetCurveBuilder(null);

        offsetCurveBuilder1.CurveFitData.Tolerance = 0.0254;
        offsetCurveBuilder1.InputCurvesOptions.InputCur
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值